﻿<?php
// Aus der as-Dokumentation:
$list=<<<EOT
     0000000000000000   nop
     00000001ddddrrrr   movw    v,v
     00000010ddddrrrr   muls    d,d
     000000110ddd0rrr   mulsu   a,a
     000000110ddd1rrr   fmul    a,a
     000000111ddd0rrr   fmuls   a,a
     000000111ddd1rrr   fmulsu  a,a
     000001rdddddrrrr   cpc     r,r
     000010rdddddrrrr   sbc     r,r
     000011rdddddrrrr   add     r,r
     000100rdddddrrrr   cpse    r,r
     000101rdddddrrrr   cp      r,r
     000110rdddddrrrr   sub     r,r
     000111rdddddrrrr   adc     r,r
     001000rdddddrrrr   and     r,r
     001001rdddddrrrr   eor     r,r
     001010rdddddrrrr   or      r,r
     001011rdddddrrrr   mov     r,r
     0011KKKKddddKKKK   cpi     d,M
     0100KKKKddddKKKK   sbci    d,M
     0101KKKKddddKKKK   subi    d,M
     0110KKKKddddKKKK   ori     d,M
     0111KKKKddddKKKK   andi    d,M
     1000000ddddd0000   ld      r,Z
     1000000ddddd1e00   ld      r,e
     1000001rrrrr0000   st      Z,r
     1000001rrrrr1e00   st      e,r
     1001000ddddd010+   lpm     r,z
     1001000ddddd011+   elpm    r,z
     1001000ddddd0001   ld      r,Z+
     1001000ddddd1e01   ld      r,e+
     1001000ddddd0010   ld      r,-Z
     1001000ddddd1e10   ld      r,-e
     1001001rrrrr0001   st      Z+,r
     1001001rrrrr1e01   st      e+,r
     1001001rrrrr0010   st      -Z,r
     1001001rrrrr1e10   st      -e,r
     1001000rrrrr1111   pop     r
     1001001rrrrr1111   push    r
     1001000ddddd0000 2 lds     r,i
     1001001ddddd0000 2 sts     i,r
     100101000SSS1000   bset    S
     100101001SSS1000   bclr    S
     1001010000001001   ijmp
     1001010000011001   eijmp
     1001010rrrrr0000   com     r
     1001010rrrrr0001   neg     r
     1001010rrrrr0010   swap    r
     1001010rrrrr0011   inc     r
     1001010rrrrr0101   asr     r
     1001010rrrrr0110   lsr     r
     1001010rrrrr0111   ror     r
     1001010rrrrr1010   dec     r
     1001010hhhhh110h 2 jmp     h
     1001010hhhhh111h 2 call    h
     1001010100001001   icall
     1001010100011001   eicall
     1001010111001000   lpm
     1001010111011000   elpm
     1001010100001000   ret
     1001010100011000   reti
     1001010110001000   sleep
     1001010110011000   break
     1001010110101000   wdr
     1001010111101000   spm
     10010110KKddKKKK   adiw    w,K
     10010111KKddKKKK   sbiw    w,K
     10011000pppppsss   cbi     p,s
     10011001pppppsss   sbic    p,s
     10011010pppppsss   sbi     p,s
     10011011pppppsss   sbis    p,s
     100111rdddddrrrr   mul     r,r
     10o0oo0dddddbooo   ldd     r,b
     10o0oo1rrrrrbooo   std     b,r
     10110PPdddddPPPP   in      r,P
     10111PPrrrrrPPPP   out     P,r
     1100LLLLLLLLLLLL   rjmp    L
     1101LLLLLLLLLLLL   rcall   L
     1110KKKKddddKKKK   ldi     d,M
     11101111dddd1111   ser     d
     111100lllllllsss   brbs    s,l
     111101lllllllsss   brbc    s,l
     1111100ddddd0sss   bld     r,s
     1111101ddddd0sss   bst     r,s
     1111110rrrrr0sss   sbrc    r,s
     1111111rrrrr0sss   sbrs    r,s
EOT;

$img=imagecreatetruecolor(256,256);
$white=imagecolorallocate($img,255,255,255);

$opc=explode("\n",$list);	// Opcodes zeilenweise
foreach ($opc as $line) {
 $v=substr($line,5,16);
 if (strlen($v)==16) {
  $v0=intval(preg_replace('/[^01]/','0',$v),2);	// minimal möglicher Wert
  $v1=intval(preg_replace('/[^01]/','1',$v),2);	// maximal möglicher Wert
  $vm=~($v1-$v0)&0xFFFF;			// Maske der festen Bits
  printf("%04X %04X\n",$v0,$v1);
  for ($v=$v0; $v<=$v1; $v++) {
   if (!(($v^$v0)&$vm))
    imagesetpixel($img,$v&0xFF,$v>>8,$white);
  }
 }
}

imagepng($img,"opcodemap.png");
imagedestroy($img);
?>
